/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Mon Mar 19 23:27:13 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00003381 (13185)
 *     Revision         0x01
 *     Checksum         0x4F
 *     OEM ID           "ACRSYS"
 *     OEM Table ID     "ACRPRDCT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "1025"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "ACRSYS", "ACRPRDCT", 0x00001000)
{
    External (ASLB, MethodObj)    // 1 Arguments
    External (LIDS, IntObj)
    External (DSEN)
    External (DID8)
    External (DID7)
    External (DID6)
    External (DID5)
    External (DID4)
    External (DID3)
    External (DID2)
    External (DID1)
    External (NDID)
    External (NVGA, MethodObj)    // 1 Arguments
    External (OPTF, IntObj)
    External (NVHA, MethodObj)    // 1 Arguments
    External (EBAS, MethodObj)    // 1 Arguments
    External (PEBS)
    External (\_SB_.PCI0.WMID)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0.CLID)
    External (\_SB_.PCI0.GFX0.AINT, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0.GLID, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.WMID.FEBC)
    External (\_SB_.PCI0.GFX0.CAL8)
    External (\_SB_.PCI0.GFX0.CAL7)
    External (\_SB_.PCI0.GFX0.CAL6)
    External (\_SB_.PCI0.GFX0.CAL5)
    External (\_SB_.PCI0.GFX0.CAL4)
    External (\_SB_.PCI0.GFX0.CAL3)
    External (\_SB_.PCI0.GFX0.CAL2)
    External (\_SB_.PCI0.GFX0.CADL)
    External (\_SB_.PCI0.GFX0.CPL8)
    External (\_SB_.PCI0.GFX0.CPL7)
    External (\_SB_.PCI0.GFX0.CPL6)
    External (\_SB_.PCI0.GFX0.CPL5)
    External (\_SB_.PCI0.GFX0.CPL4)
    External (\_SB_.PCI0.GFX0.CPL3)
    External (\_SB_.PCI0.GFX0.CPL2)
    External (\_SB_.PCI0.GFX0.CPDL)
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.LPCB.H_EC.SCAN)
    External (\_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCM, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (\_SB_.PCI0.LPCB.H_EC.LSTE)
    External (\_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (\_SB_.PCI0.LPCB.EC0_.VGAF)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Scope (\_SB.PCI0.PEG0.PEGP)
        {
            OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
            Field (GPIO, ByteAcc, Lock, Preserve)
            {
                        Offset (0x0C), 
                    ,   3, 
                PO03,   1, 
                PO04,   1, 
                    ,   12, 
                PI17,   1, 
                        Offset (0x38), 
                    ,   3, 
                PO35,   1, 
                PO36,   1, 
                    ,   13, 
                PO50,   1, 
                    ,   1, 
                PO52,   1, 
                        Offset (0x48), 
                    ,   4, 
                PI68,   1
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (PWRE, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO36)
            }

            Sleep (0x012C)
            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO35)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO35)
            }

            Sleep (0x64)
            While (LNotEqual (\_SB.PCI0.PEG0.PEGP.PI17, One))
            {
                Sleep (One)
            }

            If (Zero)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            Sleep (0x64)
        }

        Method (PWRD, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO04)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO04)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO35)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO35)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.PEG0.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.PEG0.PEGP.PO36)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        Name (B0D1, Zero)
        OperationRegion (RPCI, SystemMemory, Or (PEBS, 0x8000, B0D1), 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                    Offset (0x1FC), 
                ,   9, 
            SGL1,   1, 
                    Offset (0x214), 
                    Offset (0x216), 
            LNKS,   4, 
                    Offset (0x224), 
                    Offset (0x225), 
            DQDA,   1, 
                    Offset (0xC28), 
            HCLQ,   1, 
                    Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
                    Offset (0xDFC), 
            PEPO,   3, 
                    Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
                    Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
                    Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
                    Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
                    Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
                    Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
                    Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
                    Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
                    Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
                    Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
                    Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
                    Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
                    Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
                    Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
                    Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
                    Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
                    Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (PCIS, SystemMemory, EBAS (0x0100), Field (PCIS, ByteAcc, NoLock, Preserve)
            {
                        Offset (0x04), 
                CMDR,   8, 
                VGAR,   2008
            })
        Name (VGAB, Buffer (0xFB)
        {
            0x00
        })
        OperationRegion (NVHM, SystemMemory, NVHA (0x00010400), Field (NVHM, AnyAcc, NoLock, Preserve)
            {
                NVSG,   128, 
                NVSZ,   32, 
                NVVR,   32, 
                        Offset (0x100), 
                NVHO,   32, 
                RVBS,   32, 
                        Offset (0x180), 
                TNDI,   8, 
                DGND,   8, 
                IGND,   8, 
                        Offset (0x190), 
                        Offset (0x1B0), 
                DDI1,   32, 
                DDI2,   32, 
                DDI3,   32, 
                DDI4,   32, 
                DDI5,   32, 
                DDI6,   32, 
                DDI7,   32, 
                DDI8,   32, 
                        Offset (0x200), 
                        Offset (0x220), 
                        Offset (0x240), 
                        Offset (0x260), 
                DCP1,   32, 
                DCP2,   32, 
                DCP3,   32, 
                DCP4,   32, 
                DCP5,   32, 
                DCP6,   32, 
                DCP7,   32, 
                DCP8,   32, 
                DCA1,   32, 
                DCA2,   32, 
                DCA3,   32, 
                DCA4,   32, 
                DCA5,   32, 
                DCA6,   32, 
                DCA7,   32, 
                DCA8,   32, 
                DNA1,   32, 
                DNA2,   32, 
                DNA3,   32, 
                DNA4,   32, 
                DNA5,   32, 
                DNA6,   32, 
                DNA7,   32, 
                DNA8,   32, 
                        Offset (0x3C0), 
                RAPM,   8, 
                EAPM,   8, 
                TSLC,   16, 
                DNDI,   8, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Name (BDFR, 0x00100488)
        OperationRegion (PCNV, SystemMemory, Or (PEBS, BDFR, BDFR), 0x04)
        Field (PCNV, AnyAcc, NoLock, Preserve)
        {
                ,   25, 
            MLTF,   1
        }

        Name (OMPR, 0x02)
        Name (DGOS, Zero)
        Name (CTOI, One)
        Name (NTOI, One)
        Name (MADL, Zero)
        Name (MSTE, Zero)
        Method (VSTS, 0, NotSerialized)
        {
            If (LNotEqual (\_SB.PCI0.GFX0.CPDL, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPDL, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPDL, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL2, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL2, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL2, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL3, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL3, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL3, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL4, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL4, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL4, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL5, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL5, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL5, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL6, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL6, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL6, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL7, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL7, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL7, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CPL8, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CPL8, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GATD, 0x02, \_SB.PCI0.GFX0.GATD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CPL8, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GATD, One, \_SB.PCI0.GFX0.GATD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CADL, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CADL, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CADL, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL2, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL2, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL2, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL3, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL3, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL3, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL4, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL4, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL4, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL5, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL5, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL5, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL6, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL6, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL6, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL7, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL7, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL7, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            If (LNotEqual (\_SB.PCI0.GFX0.CAL8, Zero))
            {
                If (LEqual (\_SB.PCI0.GFX0.CAL8, And (\_SB.PCI0.GFX0.IDI1, 0xFFFF)))
                {
                    Or (\_SB.PCI0.GFX0.GACD, 0x02, \_SB.PCI0.GFX0.GACD)
                }
                Else
                {
                    If (LEqual (\_SB.PCI0.GFX0.CAL8, And (\_SB.PCI0.GFX0.IDI2, 0xFFFF)))
                    {
                        Or (\_SB.PCI0.GFX0.GACD, One, \_SB.PCI0.GFX0.GACD)
                    }
                }
            }

            Store (\_SB.PCI0.GFX0.GATD, \_SB.PCI0.PEG0.PEGP.MADL)
            Store (\_SB.PCI0.GFX0.GACD, \_SB.PCI0.PEG0.PEGP.MSTE)
            Store (Zero, \_SB.PCI0.GFX0.GATD)
            Store (Zero, \_SB.PCI0.GFX0.GACD)
        }

        Method (GETD, 2, Serialized)
        {
            Name (_T_5, Zero)
            Name (_T_4, Zero)
            Name (_T_3, Zero)
            Name (_T_2, Zero)
            Name (_T_1, Zero)
            Name (_T_0, Zero)
            VSTS ()
            Or (\_SB.PCI0.PEG0.PEGP.MADL, Arg0, \_SB.PCI0.PEG0.PEGP.MADL)
            Or (\_SB.PCI0.PEG0.PEGP.MSTE, Arg1, \_SB.PCI0.PEG0.PEGP.MSTE)
            While (One)
            {
                Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MADL), _T_0)
                If (LEqual (_T_0, 0x07))
                {
                    While (One)
                    {
                        Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MSTE), _T_1)
                        If (LEqual (_T_1, One))
                        {
                            Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                            Store (0x02, \_SB.PCI0.PEG0.PEGP.NTOI)
                        }
                        Else
                        {
                            If (LEqual (_T_1, 0x02))
                            {
                                Store (0x02, \_SB.PCI0.PEG0.PEGP.CTOI)
                                Store (0x03, \_SB.PCI0.PEG0.PEGP.NTOI)
                            }
                            Else
                            {
                                If (LEqual (_T_1, 0x04))
                                {
                                    Store (0x03, \_SB.PCI0.PEG0.PEGP.CTOI)
                                    Store (0x04, \_SB.PCI0.PEG0.PEGP.NTOI)
                                }
                                Else
                                {
                                    If (LEqual (_T_1, 0x03))
                                    {
                                        Store (0x04, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (0x05, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_1, 0x05))
                                        {
                                            Store (0x05, \_SB.PCI0.PEG0.PEGP.CTOI)
                                            Store (0x06, \_SB.PCI0.PEG0.PEGP.NTOI)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_1, 0x06))
                                            {
                                                Store (0x06, \_SB.PCI0.PEG0.PEGP.CTOI)
                                                Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                            }
                                            Else
                                            {
                                                Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                                Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        Break
                    }
                }
                Else
                {
                    If (LEqual (_T_0, 0x06))
                    {
                        While (One)
                        {
                            Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MSTE), _T_2)
                            If (LEqual (_T_2, 0x02))
                            {
                                Store (0x02, \_SB.PCI0.PEG0.PEGP.CTOI)
                                Store (0x03, \_SB.PCI0.PEG0.PEGP.NTOI)
                            }
                            Else
                            {
                                If (LEqual (_T_2, 0x04))
                                {
                                    Store (0x03, \_SB.PCI0.PEG0.PEGP.CTOI)
                                    Store (0x06, \_SB.PCI0.PEG0.PEGP.NTOI)
                                }
                                Else
                                {
                                    If (LEqual (_T_2, 0x06))
                                    {
                                        Store (0x06, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (0x02, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                    Else
                                    {
                                        Store (0x02, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (0x02, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                }
                            }

                            Break
                        }
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x05))
                        {
                            While (One)
                            {
                                Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MSTE), _T_3)
                                If (LEqual (_T_3, One))
                                {
                                    Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                    Store (0x03, \_SB.PCI0.PEG0.PEGP.NTOI)
                                }
                                Else
                                {
                                    If (LEqual (_T_3, 0x04))
                                    {
                                        Store (0x03, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (0x05, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_3, 0x05))
                                        {
                                            Store (0x05, \_SB.PCI0.PEG0.PEGP.CTOI)
                                            Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                        }
                                        Else
                                        {
                                            Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                            Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                        }
                                    }
                                }

                                Break
                            }
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                While (One)
                                {
                                    Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MSTE), _T_4)
                                    If (LEqual (_T_4, One))
                                    {
                                        Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (0x02, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_4, 0x02))
                                        {
                                            Store (0x02, \_SB.PCI0.PEG0.PEGP.CTOI)
                                            Store (0x04, \_SB.PCI0.PEG0.PEGP.NTOI)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_4, 0x03))
                                            {
                                                Store (0x04, \_SB.PCI0.PEG0.PEGP.CTOI)
                                                Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                            }
                                            Else
                                            {
                                                Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                                Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                            }
                                        }
                                    }

                                    Break
                                }
                            }
                            Else
                            {
                                While (One)
                                {
                                    Store (ToInteger (\_SB.PCI0.PEG0.PEGP.MSTE), _T_5)
                                    If (LEqual (_T_5, One))
                                    {
                                        Store (One, \_SB.PCI0.PEG0.PEGP.CTOI)
                                        Store (One, \_SB.PCI0.PEG0.PEGP.NTOI)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_5, 0x02))
                                        {
                                            Store (0x02, \_SB.PCI0.PEG0.PEGP.CTOI)
                                            Store (0x02, \_SB.PCI0.PEG0.PEGP.NTOI)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_5, 0x04))
                                            {
                                                Store (0x03, \_SB.PCI0.PEG0.PEGP.CTOI)
                                                Store (0x03, \_SB.PCI0.PEG0.PEGP.NTOI)
                                            }
                                        }
                                    }

                                    Break
                                }
                            }
                        }
                    }
                }

                Break
            }
        }

        Method (NVOP, 4, Serialized)
        {
            Name (_T_0, Zero)
            Store ("------- NV OPTIMUS DSM --------", Debug)
            If (LNotEqual (Arg1, 0x0100))
            {
                Return (0x80000001)
            }

            While (One)
            {
                Store (ToInteger (Arg2), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Store (Buffer (0x04)
                        {
                            0x61, 0x00, 0x01, 0x0C
                        }, Local0)
                    Return (Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x05))
                    {
                        Name (TMP5, Buffer (0x04)
                        {
                            0x00, 0x00, 0x00, 0x00
                        })
                        CreateField (TMP5, Zero, 0x04, DAVF)
                        CreateField (TMP5, 0x04, One, LIDF)
                        CreateField (TMP5, 0x08, 0x06, TOGN)
                        CreateField (Arg3, 0x1F, One, NCSM)
                        CreateField (Arg3, 0x19, 0x05, NCSN)
                        CreateField (Arg3, 0x18, One, DIMK)
                        CreateField (Arg3, 0x0C, 0x0C, ACTD)
                        CreateField (Arg3, Zero, 0x0C, ATTD)
                        If (ToInteger (NCSM))
                        {
                            Store (ToInteger (NCSN), TOGN)
                        }
                        Else
                        {
                            If (ToInteger (DIMK))
                            {
                                GETD (ToInteger (ATTD), ToInteger (ACTD))
                                Store (\_SB.PCI0.PEG0.PEGP.NTOI, TOGN)
                                Store (One, DAVF)
                            }
                        }

                        Return (TMP5)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x06))
                        {
                            Name (TMP6, Package (0x0F)
                            {
                                Ones, 
                                0x2C, 
                                Ones, 
                                0x2C, 
                                Ones, 
                                0x2C, 
                                Ones, 
                                Ones, 
                                0x2C, 
                                Ones, 
                                Ones, 
                                0x2C, 
                                Ones, 
                                Ones, 
                                0x2C
                            })
                            Store (\_SB.PCI0.GFX0.IDI2, Index (TMP6, Zero))
                            Store (\_SB.PCI0.GFX0.IDI1, Index (TMP6, 0x02))
                            Store (\_SB.PCI0.GFX0.IDI4, Index (TMP6, 0x04))
                            Store (\_SB.PCI0.GFX0.IDI2, Index (TMP6, 0x06))
                            Store (\_SB.PCI0.GFX0.IDI1, Index (TMP6, 0x07))
                            Store (\_SB.PCI0.GFX0.IDI2, Index (TMP6, 0x09))
                            Store (\_SB.PCI0.GFX0.IDI4, Index (TMP6, 0x0A))
                            Store (\_SB.PCI0.GFX0.IDI1, Index (TMP6, 0x0C))
                            Store (\_SB.PCI0.GFX0.IDI4, Index (TMP6, 0x0D))
                            Return (TMP6)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x10))
                            {
                                Return (\_SB.PCI0.PEG0.PEGP.GOBT (Arg3))
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x1A))
                                {
                                    CreateField (Arg3, 0x18, 0x02, OPCE)
                                    CreateField (Arg3, Zero, One, FLCH)
                                    If (ToInteger (FLCH))
                                    {
                                        Store (ToInteger (OPCE), OMPR)
                                    }

                                    Name (RBUF, Buffer (0x04)
                                    {
                                        0x00, 0x00, 0x00, 0x00
                                    })
                                    CreateField (RBUF, Zero, One, OPEN)
                                    CreateField (RBUF, 0x03, 0x02, CGCS)
                                    CreateField (RBUF, 0x06, One, SHPC)
                                    CreateField (RBUF, 0x18, 0x03, DGPC)
                                    CreateField (RBUF, 0x1B, 0x02, HDAC)
                                    Store (One, OPEN)
                                    Store (One, SHPC)
                                    Store (0x02, HDAC)
                                    Store (One, DGPC)
                                    If (\_SB.PCI0.PEG0.PEGP.GSTA ())
                                    {
                                        Store (0x03, CGCS)
                                    }
                                    Else
                                    {
                                        Store (Zero, CGCS)
                                    }

                                    Return (RBUF)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x1B))
                                    {
                                        Store (Arg3, Local0)
                                        CreateField (Local0, Zero, One, OPFL)
                                        CreateField (Local0, One, One, OPVL)
                                        If (ToInteger (OPVL))
                                        {
                                            Store (Zero, OPTF)
                                            If (ToInteger (OPFL))
                                            {
                                                Store (One, OPTF)
                                            }
                                        }

                                        Store (OPTF, Local0)
                                        Return (Local0)
                                    }
                                    Else
                                    {
                                        Return (0x80000002)
                                    }
                                }
                            }
                        }
                    }
                }

                Break
            }
        }

        Method (GOBT, 1, NotSerialized)
        {
            Name (OPVK, Buffer (0xE2)
            {
                /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0020 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0028 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0030 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0038 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0040 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0048 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0050 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0058 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0060 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0068 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0070 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0078 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0080 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0088 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0090 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0098 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00A0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00A8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00B0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00B8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00C0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00C8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00D0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00D8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00E0 */    0x00, 0x00
            })
            CreateWordField (Arg0, 0x02, USRG)
            If (LEqual (USRG, 0x564B))
            {
                Return (OPVK)
            }

            Return (Zero)
        }

        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
        }

        Method (GSTA, 0, Serialized)
        {
            If (LEqual (\_SB.PCI0.PEG0.PEGP.PI17, One))
            {
                Return (One)
            }
            Else
            {
                Return (Zero)
            }
        }

        Method (_ON, 0, Serialized)
        {
            Store (0x03, Index (\_SB.PCI0.WMID.FEBC, One))
            Store (0x03, Index (\_SB.PCI0.WMID.FEBC, Zero))
            Notify (\_SB.PCI0.WMID, 0xBC)
            \_SB.PCI0.PEG0.PEGP.PWRE ()
            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (Zero, CMDR)
            Store (VGAB, VGAR)
            Store (0x06, CMDR)
            Store (One, \_SB.PCI0.LPCB.EC0.VGAF)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (0x02, Index (\_SB.PCI0.WMID.FEBC, One))
            Store (0x03, Index (\_SB.PCI0.WMID.FEBC, Zero))
            Notify (\_SB.PCI0.WMID, 0xBC)
            Store (VGAR, VGAB)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            \_SB.PCI0.PEG0.PEGP.PWRD ()
            Store (Zero, \_SB.PCI0.LPCB.EC0.VGAF)
        }

        Method (_PS0, 0, NotSerialized)
        {
            If (DGOS)
            {
                GLSC ()
                \_SB.PCI0.PEG0.PEGP._ON ()
                GLSR ()
                Store (Zero, DGOS)
                Store (Zero, MLTF)
            }
        }

        Method (_PS3, 0, NotSerialized)
        {
            Store (MLTF, OPTF)
            If (LEqual (\_SB.PCI0.PEG0.PEGP.OMPR, 0x03))
            {
                GLSC ()
                \_SB.PCI0.PEG0.PEGP._OFF ()
                GLSR ()
                Store (One, DGOS)
                Store (0x02, \_SB.PCI0.PEG0.PEGP.OMPR)
            }
        }

        Method (_STA, 0, Serialized)
        {
            Return (0x0F)
        }

        Method (_ROM, 2, NotSerialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }

        Method (_DSM, 4, Serialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xF8, 0xD8, 0x86, 0xA4, 0xDA, 0x0B, 0x1B, 0x47, 
                        /* 0008 */    0xA7, 0x2B, 0x60, 0x42, 0xA6, 0xB5, 0xBE, 0xE0
                    }))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000001)
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (Package (0x01)
            {
                0x80087330
            })
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI1, Zero))
                {
                    If (LEqual (DCA1, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI1))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI1))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI1, Zero))
                {
                    If (LEqual (DNA1, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI1))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI1))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI2, Zero))
                {
                    If (LEqual (\_SB.PCI0.LPCB.H_EC.LSTE, Zero))
                    {
                        Return (Zero)
                    }
                    Else
                    {
                        If (LEqual (DCA1, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA2, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA3, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA4, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA5, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA6, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA7, DDI2))
                        {
                            Return (0x1F)
                        }

                        If (LEqual (DCA8, DDI2))
                        {
                            Return (0x1F)
                        }
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI2, Zero))
                {
                    If (LEqual (DNA1, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI2))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI2))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }

            Method (_BCL, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL)
            }

            Method (_BQC, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC)
            }

            Method (_BCM, 1, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCM)
                Arg0
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI3, Zero))
                {
                    If (LEqual (DCA1, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI3))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI3))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI3, Zero))
                {
                    If (LEqual (DNA1, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI3))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI3))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI4, Zero))
                {
                    If (LEqual (DCA1, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI4))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI4))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI4, Zero))
                {
                    If (LEqual (DNA1, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI4))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI4))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI5, Zero))
                {
                    If (LEqual (DCA1, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI5))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI5))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI5, Zero))
                {
                    If (LEqual (DNA1, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI5))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI5))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI6, Zero))
                {
                    If (LEqual (DCA1, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI6))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI6))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI6, Zero))
                {
                    If (LEqual (DNA1, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI6))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI6))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI7, Zero))
                {
                    If (LEqual (DCA1, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI7))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI7))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI7, Zero))
                {
                    If (LEqual (DNA1, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI7))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI7))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR)
            }

            Method (_DCS, 0, NotSerialized)
            {
                If (LNotEqual (DDI8, Zero))
                {
                    If (LEqual (DCA1, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA2, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA3, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA4, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA5, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA6, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA7, DDI8))
                    {
                        Return (0x1F)
                    }

                    If (LEqual (DCA8, DDI8))
                    {
                        Return (0x1F)
                    }
                }

                Return (0x1D)
            }

            Method (_DGS, 0, NotSerialized)
            {
                If (LNotEqual (DDI8, Zero))
                {
                    If (LEqual (DNA1, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA2, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA3, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA4, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA5, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA6, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA7, DDI8))
                    {
                        Return (One)
                    }

                    If (LEqual (DNA8, DDI8))
                    {
                        Return (One)
                    }
                }

                Return (Zero)
            }

            Method (_DSS, 1, NotSerialized)
            {
            }
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        OperationRegion (NVIG, SystemMemory, NVGA (0x0400), Field (NVIG, AnyAcc, NoLock, Preserve)
            {
                NISG,   128, 
                NISZ,   32, 
                NIVR,   32, 
                        Offset (0x100), 
                HGEN,   8, 
                GOMC,   8, 
                GPSC,   8, 
                GPCS,   8, 
                GPRC,   8, 
                MHPC,   8, 
                MDAC,   8, 
                EJCA,   8, 
                        Offset (0x180), 
                IDI1,   32, 
                IDI2,   32, 
                IDI3,   32, 
                IDI4,   32, 
                IDI5,   32, 
                IDI6,   32, 
                IDI7,   32, 
                IDI8,   32, 
                INDI,   8, 
                DGPN,   8, 
                        Offset (0x1B0), 
                GPSS,   32, 
                CGPU,   32, 
                        Offset (0x200), 
                GACD,   16, 
                GATD,   16, 
                GNAD,   16, 
                TLST,   8, 
                LDES,   8, 
                DKST,   8, 
                DACE,   8, 
                DHPE,   8, 
                DHPS,   8, 
                PDHS,   8, 
                        Offset (0x2E0), 
                HGNC,   8, 
                HENC,   8, 
                        Offset (0x300), 
                GUPM,   8, 
                GPPO,   8, 
                        Offset (0x310), 
                UBDM,   8, 
                USPM,   8, 
                UTCM,   8, 
                UTPM,   8, 
                        Offset (0x3C0), 
                GBDP,   8, 
                GPSP,   8, 
                PTVC,   8, 
                PTVF,   8, 
                ELPT,   8, 
                TLSN,   8
            })
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    Return (Buffer (0x04)
                    {
                        0x01, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    Return (Package (0x08)
                    {
                        0x07, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                0x01, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                0x02, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80016300, 
                            Buffer (0x04)
                            {
                                0x08, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80017301, 
                            Buffer (0x04)
                            {
                                0x04, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80017302, 
                            Buffer (0x04)
                            {
                                0x05, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80016303, 
                            Buffer (0x04)
                            {
                                0x0A, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80017304, 
                            Buffer (0x04)
                            {
                                0x06, 0x03, 0x03, 0x03
                            }
                        }
                    })
                }

                Return (One)
            }

            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xA0, 0xA0, 0x95, 0x9D, 0x60, 0x00, 0x48, 0x4D, 
                        /* 0008 */    0xB3, 0x4D, 0x7E, 0x5F, 0xEA, 0x12, 0x9F, 0xD4
                    }))
            {
                Return (Buffer (0x04)
                {
                    0x02, 0x00, 0x00, 0x80
                })
            }

            Return (0x80000001)
        }
    }

    Name (BDFR, 0x000F804C)
    OperationRegion (GPCR, SystemMemory, Or (PEBS, BDFR, BDFR), One)
    Field (GPCR, AnyAcc, NoLock, Preserve)
    {
        GPCT,   1
    }

    Name (GPLS, Zero)
    Method (GLSC, 0, Serialized)
    {
        Store (GPCT, GPLS)
        If (LEqual (GPCT, One))
        {
            Store (Zero, GPCT)
        }
    }

    Method (GLSR, 0, Serialized)
    {
        Store (GPLS, GPCT)
    }

    Method (IDAB, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.IDI1, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI1, DID1)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI2, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI2, DID2)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI3, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI3, DID3)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI4, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI4, DID4)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI5, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI5, DID5)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI6, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI6, DID6)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI7, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI7, DID7)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.IDI8, Zero))
        {
            Increment (NDID)
            Or (0x80000000, \_SB.PCI0.GFX0.IDI8, DID8)
        }
    }

    Method (HGAS, 0, Serialized)
    {
    }

    Method (HBRT, 1, Serialized)
    {
        Store (Arg0, \_SB.PCI0.GFX0.DACE)
        If (And (0x04, DSEN))
        {
            If (LEqual (Arg0, 0x04))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x87)
            }

            If (LEqual (Arg0, 0x03))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x86)
            }
        }
    }

    Method (HLSE, 0, Serialized)
    {
        Store (0x02, \_SB.PCI0.GFX0.DACE)
        Store (One, \_SB.PCI0.GFX0.LDES)
        Store (0x02, \_SB.PCI0.GFX0.DHPE)
        Store (LIDS, \_SB.PCI0.GFX0.DHPS)
        If (LEqual (\_SB.PCI0.GFX0.CGPU, One))
        {
            \_SB.PCI0.GFX0.GLID (LIDS)
        }
        Else
        {
            Notify (\_SB.PCI0.GFX0, 0xDB)
            Notify (\_SB.PCI0.PEG0.PEGP, 0x81)
        }
    }

    Method (HDSE, 1, Serialized)
    {
        Store (One, \_SB.PCI0.GFX0.DACE)
        Subtract (\_SB.PCI0.LPCB.H_EC.SCAN, 0x3A, \_SB.PCI0.GFX0.TLST)
        If (LEqual (\_SB.PCI0.GFX0.TLSN, 0x0D))
        {
            Store (One, \_SB.PCI0.GFX0.TLSN)
        }
        Else
        {
            Increment (\_SB.PCI0.GFX0.TLSN)
        }

        Notify (\_SB.PCI0.GFX0, 0x80)
    }

    Method (HPFS, 0, Serialized)
    {
        If (LEqual (\_SB.PCI0.GFX0.CGPU, One))
        {
            \_SB.PCI0.GFX0.AINT (0x02, Zero)
        }
        Else
        {
            Store (0x05, \_SB.PCI0.GFX0.DACE)
            If (LEqual (\_SB.PCI0.GFX0.GPSP, 0x02))
            {
                Store (Zero, \_SB.PCI0.GFX0.GPSP)
            }
            Else
            {
                Increment (\_SB.PCI0.GFX0.GPSP)
            }

            Notify (\_SB.PCI0.GFX0, 0xE1)
        }
    }

    Method (HGLS, 0, Serialized)
    {
        Store (0x02, \_SB.PCI0.GFX0.DACE)
        Store (One, \_SB.PCI0.GFX0.LDES)
        Store (0x02, \_SB.PCI0.GFX0.DHPE)
        Store (LIDS, \_SB.PCI0.GFX0.DHPS)
        If (LEqual (\_SB.PCI0.GFX0.CGPU, One))
        {
            If (\_SB.PCI0.GFX0.GLID (LIDS))
            {
                Or (0x80000000, \_SB.PCI0.GFX0.CLID, \_SB.PCI0.GFX0.CLID)
            }
        }
        Else
        {
            Notify (\_SB.PCI0.GFX0, 0xDB)
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        Increment (\_SB.PCI0.GFX0.GPSS)
        Mod (\_SB.PCI0.GFX0.GPSS, 0x03, \_SB.PCI0.GFX0.GPSS)
        Store (One, \_SB.PCI0.GFX0.GPPO)
        Store (One, \_SB.PCI0.GFX0.HGNC)
        Notify (\_SB.PCI0.GFX0, 0xD0)
    }

    Scope (\_SB.PCI0)
    {
        Name (OTM, "OTMACPI 2010-Mar-09 12:08:26")
    }
}

